/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.common.enums.BaseExceptionEnum
 *  com.deepexi.scd.common.enums.ExceptionEnum
 *  com.deepexi.scd.common.util.ThrowEnumUtils
 *  com.deepoove.poi.XWPFTemplate
 *  com.deepoove.poi.config.Configure
 *  freemarker.template.Configuration
 *  freemarker.template.Template
 *  javax.servlet.ServletOutputStream
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.core.io.ClassPathResource
 *  org.springframework.web.context.request.RequestContextHolder
 *  org.springframework.web.context.request.ServletRequestAttributes
 */
package com.deepexi.scd.calculate.util;

import com.deepexi.scd.common.enums.BaseExceptionEnum;
import com.deepexi.scd.common.enums.ExceptionEnum;
import com.deepexi.scd.common.util.ThrowEnumUtils;
import com.deepoove.poi.XWPFTemplate;
import com.deepoove.poi.config.Configure;
import freemarker.template.Configuration;
import freemarker.template.Template;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Map;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

public class ExportWord {
    private static final Logger log = LoggerFactory.getLogger(ExportWord.class);
    private Configuration configuration;
    private String encoding;
    private String exportPath = "D:\\test\\";

    public ExportWord(String encoding) {
        this.encoding = encoding;
        this.configuration = new Configuration(Configuration.VERSION_2_3_31);
        this.configuration.setDefaultEncoding(encoding);
        this.configuration.setClassForTemplateLoading(this.getClass(), "/templates");
    }

    public Template getTemplate(String name) throws Exception {
        return this.configuration.getTemplate(name);
    }

    public void exportDocFile(String fileName, String tplName, Map<String, Object> data) throws Exception {
        log.info("导出word");
        File exportDirs = new File(this.exportPath);
        if (!exportDirs.exists()) {
            exportDirs.mkdirs();
        }
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter((OutputStream)new FileOutputStream(this.exportPath + fileName), this.encoding));
        this.getTemplate(tplName).process(data, (Writer)writer);
    }

    public InputStream exportInputStream(String tplName, Map<String, Object> data) throws Exception {
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        BufferedWriter writerEx = new BufferedWriter(new OutputStreamWriter(byteArrayOutputStream));
        this.getTemplate(tplName).process(data, (Writer)writerEx);
        ((Writer)writerEx).close();
        ByteArrayInputStream inputStream = new ByteArrayInputStream(byteArrayOutputStream.toByteArray());
        ((InputStream)inputStream).close();
        return inputStream;
    }

    public void exportDoc(String fileName, String tplName, Map<String, Object> data) throws Exception {
        HttpServletResponse response = ExportWord.currentResponse();
        response.reset();
        response.setCharacterEncoding("UTF-8");
        response.setContentType("application/msword");
        response.setHeader("Content-Disposition", "attachment; filename=" + URLEncoder.encode(fileName, "UTF-8"));
        PrintWriter out = response.getWriter();
        Template template = this.getTemplate(tplName);
        template.process(data, (Writer)out);
        ((Writer)out).close();
    }

    public InputStream generateReport(String tplName, Map<String, Object> data) throws Exception {
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        OutputStreamWriter writer = new OutputStreamWriter((OutputStream)outputStream, StandardCharsets.UTF_8);
        Template template = this.getTemplate(tplName);
        template.process(data, (Writer)writer);
        byte[] bytes = outputStream.toByteArray();
        ByteArrayInputStream inputStream = new ByteArrayInputStream(bytes);
        outputStream.flush();
        outputStream.close();
        return inputStream;
    }

    public void exportReportDoc(InputStream inputStream, String fileName) throws Exception {
        HttpServletResponse response = ExportWord.currentResponse();
        byte[] buffer = new byte[1024];
        int length = 0;
        response.reset();
        response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(fileName, "UTF-8"));
        response.setContentType("application/msword");
        response.setCharacterEncoding("utf-8");
        ServletOutputStream outputStream = response.getOutputStream();
        while ((length = inputStream.read(buffer)) > 0) {
            outputStream.write(buffer, 0, length);
        }
        outputStream.flush();
        outputStream.close();
    }

    private static HttpServletResponse currentResponse() {
        ServletRequestAttributes attrs = (ServletRequestAttributes)RequestContextHolder.getRequestAttributes();
        ThrowEnumUtils.isNull((Object)attrs).throwMessage((BaseExceptionEnum)ExceptionEnum.SCHEMA_NOT_MATCH, new Object[0]);
        return attrs.getResponse();
    }

    public InputStream downloadWord(String templateName, Map<String, Object> paramMap) throws Exception {
        String basePath = "templates/doc/";
        String url = basePath + templateName;
        ClassPathResource resource = new ClassPathResource(url);
        log.info("--downloadWord---path={}", (Object)resource);
        Configure config = (Configure)paramMap.get("config");
        XWPFTemplate template = XWPFTemplate.compile((InputStream)resource.getInputStream(), (Configure)config).render(paramMap);
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        template.write((OutputStream)outputStream);
        byte[] bytes = outputStream.toByteArray();
        ByteArrayInputStream inputStream = new ByteArrayInputStream(bytes);
        outputStream.flush();
        outputStream.close();
        template.close();
        return inputStream;
    }
}

